/*
 * (C) Copyright 1996- ECMWF.
 *
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
 * In applying this licence, ECMWF does not waive the privileges and immunities
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.
 */

/// @author Baudouin Raoult
/// @author Tiago Quintino
///
/// @date Jan 2016

#ifndef metkit_grib_GribFile_H
#define metkit_grib_GribFile_H

#include "eckit/memory/NonCopyable.h"
#include "eckit/io/StdFile.h"
#include "eckit/filesystem/PathName.h"

namespace eckit { class PathName; }

namespace metkit {
namespace grib {

  class GribHandle;

//----------------------------------------------------------------------------------------------------------------------

class GribFile : private eckit::NonCopyable {

public: // methods

    GribFile(const eckit::PathName&);

    /// @throws due to StdFile
    ~GribFile() noexcept(false);

    GribHandle* next();

private: // members

    eckit::PathName path_;

    eckit::StdFile file_;

};

//----------------------------------------------------------------------------------------------------------------------

} // namespace grib
} // namespace metkit

#endif
