# Import file for ODB package
#
# ODB_ENVIRONMENT - list of run-time environment variables
# ODB_SCHEMAS     - list of pre-compiled schemas

set(ODB_ENVIRONMENT "ODB_ROOT=/usr;ODB_SYSPATH=/usr/include;ODB_BINPATH=/usr/bin;ODB_BEBINPATH=/usr/bin;ODB_FEBINPATH=/usr/bin;ODB_LIBPATH=/usr/lib;ODB_RTABLE_PATH=/usr/share/odb;ODB_SYSDBPATH=/usr/share/odb;ODB_CC=/usr/bin/cc -g -O2 -fdebug-prefix-map=/build/odb-api=. -fstack-protector-strong -Wformat -Werror=format-security -Wdate-time -D_FORTIFY_SOURCE=2 -pipe -fopenmp -fPIC -I/usr/include;ODB_F90=/usr/bin/gfortran -g -O2 -fdebug-prefix-map=/build/odb-api=. -fstack-protector-strong -fopenmp -fPIC -ffree-line-length-none -I/usr/include -I/usr/module -I/usr/odb/module;ODB_COMPILER=/usr/bin/odb98.x -V -O3;ODB_COMPILER_FLAGS=/usr/share/odb/odb98.flags;ODB_STATIC_LINKING=1;ODB_LD_SHARED=none;ODB_LD_SHARED_SFX=.so;ODB_IOASSIGN_MAXPROC=32;ODB_IOASSIGN_PARAMS=-r 1m -w 1m;ODB_AR=/usr/bin/ar;ODB_GZIP=/bin/gzip;ODB_GUNZIP=/bin/gunzip;ODB_SETUP_SHELL=/bin/sh")
set(ODB_SCHEMAS "CCMA;COUNTRYRSTRHBIAS;ECMA;ERACOUNTRYTTABLE11;ERACOUNTRYTTABLE12;MTOCOMP;PSBIAS;RSTBIAS;SONDETYPERSTRHBIAS;SONDETYPES")

foreach(schema ${ODB_SCHEMAS})
    set(ODB_HAVE_${schema} 1)
endforeach()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR})

list(APPEND ODB_INCLUDE_DIRS "${ODB_CMAKE_DIR}/../../../module")
